unit Polar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Menus, ExtDlgs, lmdctrl, lmdextcA;

type
  TfrmMain = class(TForm)
    Image: TImage;
    btnLight: TButton;
    btnMLines: TButton;
    Label4: TLabel;
    TrackBarM: TTrackBar;
    Label5: TLabel;
    TrackBarQ: TTrackBar;
    btnSpace1: TButton;
    btnSpace2: TButton;
    btnColor: TButton;
    ColorDialog: TColorDialog;
    PopupMenu: TPopupMenu;
    mnuSave: TMenuItem;
    SavePictureDialog: TSavePictureDialog;
    LMDScrollText: TLMDScrollText;
    mnuAboit: TMenuItem;
    TrackBarAlfa: TTrackBar;
    Label1: TLabel;
    LblAlfa: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnLightClick(Sender: TObject);
    procedure btnSpace1Click(Sender: TObject);
    procedure btnSpace2Click(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuAboitClick(Sender: TObject);
    procedure LMDScrollTextClick(Sender: TObject);
    procedure btnMLinesClick(Sender: TObject);
    procedure TrackBarAlfaChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  x,y,z,mx,t,dt,q,m,v,vx,vy,vz,fx,fy,fz,al:real;
  e,ex,ey,ez,b,bx,by,bz:real;
  j,gd,gm,x8,y8:integer;
  ll:boolean;
  ccl:TColor;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Image.Width:=768;
  Image.Height:=512;
  TrackBarM.Position:=5;
  TrackBarQ.Position:=5;
  TrackBarAlfa.Position:=85;
  ccl:=$02ffffff;
end;

procedure TfrmMain.btnLightClick(Sender: TObject);
begin
  t:=0;
  m:=6*(TrackBarM.Position+10)/15*9.1e-31; v:=2e7;
  al:=TrackBarAlfa.Position;
  q:=-1.6e-19*(TrackBarQ.Position+10)/15;
  al:=al*pi/180;
  mx:=2e4;
  ex:=3e3; ey:=0; ez:=0;
  bx:=0.1; by:=0.0; bz:=0.0;
  gd:=0;
  x:=0;y:=0;z:=0; dt:=1e-12;
  vx:=v*cos(al);vy:=v*sin(al);vz:=0;
  repeat
    fx:=q*(ex+(vy*bz-vz*by)); vx:=vx+fx*dt/m; x:=x+vx*dt;
    fy:=q*(ey+(vz*bx-vx*bz)); vy:=vy+fy*dt/m; y:=y+vy*dt;
    fz:=q*(ez+(vx*by-vy*bx)); vz:=vz+fz*dt/m; z:=z+vz*dt;
    x8:=100+round((x-z/3)*mx);
    y8:=225-round((y-z/3)*mx);
    frmMain.Image.Canvas.Pixels[x8,y8]:=ccl;
    ll:=(x8<0)or(x8>630)or(y8<0)or(y8>450);
    t:=t+dt;
  until (t>5e-8)
end;

procedure TfrmMain.btnSpace1Click(Sender: TObject);
begin
  frmMain.Image.Picture.LoadFromFile('Space2.bmp')
end;

procedure TfrmMain.btnSpace2Click(Sender: TObject);
begin
  frmMain.Image.Picture.LoadFromFile('Space1.bmp')
end;

procedure TfrmMain.btnColorClick(Sender: TObject);
begin
  if ColorDialog.Execute
    then
      ccl:=ColorDialog.Color
end;

procedure TfrmMain.mnuSaveClick(Sender: TObject);
begin
  if SavePictureDialog.Execute
    then
      begin
        Image.Picture.SaveToFile(SavePictureDialog.FileName+'.bmp')
      end
end;

procedure TfrmMain.mnuAboitClick(Sender: TObject);
begin
  btnMLines.Enabled:=false;
  btnLight.Enabled:=false;
  LMDScrollText.Visible:=true;
  LMDScrollText.Scroll:=true
end;

procedure TfrmMain.LMDScrollTextClick(Sender: TObject);
begin
  LMDScrollText.Scroll:=false;
  LMDScrollText.Visible:=false;
  btnMLines.Enabled:=true;
  btnLight.Enabled:=true;
end;

procedure TfrmMain.btnMLinesClick(Sender: TObject);
begin
  frmMain.Image.Canvas.Pen.Color:=ccl;
  frmMain.Image.Canvas.moveTo(10,260);
  frmMain.Image.Canvas.lineTo(630,260);
  frmMain.Image.Canvas.moveTo(100,100);
  frmMain.Image.Canvas.lineTo(100,450);
  frmMain.Image.Canvas.moveTo(150,210);
  frmMain.Image.Canvas.lineTo(20,340);
end;

procedure TfrmMain.TrackBarAlfaChange(Sender: TObject);
  var h:string;
begin
  str(TrackBarAlfa.Position,h);
  lblAlfa.caption:=h
end;

end.
